(function (require$$1, require$$3) {
  'use strict';

  function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

  var require$$1__default = /*#__PURE__*/_interopDefaultLegacy(require$$1);
  var require$$3__default = /*#__PURE__*/_interopDefaultLegacy(require$$3);

  function _typeof(obj) {
    "@babel/helpers - typeof";

    if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
      _typeof = function (obj) {
        return typeof obj;
      };
    } else {
      _typeof = function (obj) {
        return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
      };
    }

    return _typeof(obj);
  }

  function _defineProperty(obj, key, value) {
    if (key in obj) {
      Object.defineProperty(obj, key, {
        value: value,
        enumerable: true,
        configurable: true,
        writable: true
      });
    } else {
      obj[key] = value;
    }

    return obj;
  }

  function ownKeys(object, enumerableOnly) {
    var keys = Object.keys(object);

    if (Object.getOwnPropertySymbols) {
      var symbols = Object.getOwnPropertySymbols(object);
      if (enumerableOnly) symbols = symbols.filter(function (sym) {
        return Object.getOwnPropertyDescriptor(object, sym).enumerable;
      });
      keys.push.apply(keys, symbols);
    }

    return keys;
  }

  function _objectSpread2(target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i] != null ? arguments[i] : {};

      if (i % 2) {
        ownKeys(Object(source), true).forEach(function (key) {
          _defineProperty(target, key, source[key]);
        });
      } else if (Object.getOwnPropertyDescriptors) {
        Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
      } else {
        ownKeys(Object(source)).forEach(function (key) {
          Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
        });
      }
    }

    return target;
  }

  function _slicedToArray(arr, i) {
    return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest();
  }

  function _arrayWithHoles(arr) {
    if (Array.isArray(arr)) return arr;
  }

  function _iterableToArrayLimit(arr, i) {
    if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return;
    var _arr = [];
    var _n = true;
    var _d = false;
    var _e = undefined;

    try {
      for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) {
        _arr.push(_s.value);

        if (i && _arr.length === i) break;
      }
    } catch (err) {
      _d = true;
      _e = err;
    } finally {
      try {
        if (!_n && _i["return"] != null) _i["return"]();
      } finally {
        if (_d) throw _e;
      }
    }

    return _arr;
  }

  function _unsupportedIterableToArray(o, minLen) {
    if (!o) return;
    if (typeof o === "string") return _arrayLikeToArray(o, minLen);
    var n = Object.prototype.toString.call(o).slice(8, -1);
    if (n === "Object" && o.constructor) n = o.constructor.name;
    if (n === "Map" || n === "Set") return Array.from(o);
    if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
  }

  function _arrayLikeToArray(arr, len) {
    if (len == null || len > arr.length) len = arr.length;

    for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i];

    return arr2;
  }

  function _nonIterableRest() {
    throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
  }

  var $ = jQuery;
  function debounce(callback, wait) {
    var immediate = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;
    var timeout = null;
    return function () {
      var _arguments = arguments,
          _this = this;

      var callNow = immediate && !timeout;

      var next = function next() {
        return callback.apply(_this, _arguments);
      };

      clearTimeout(timeout);
      timeout = setTimeout(next, wait);

      if (callNow) {
        next();
      }
    };
  }
  function clone(o) {
    // If Date or Proto disabling is needed, use: https://github.com/davidmarkclements/rfdc
    var out, val, key;

    if (_typeof(o) !== "object" || o === null) {
      return o;
    }

    out = Array.isArray(o) ? [] : {};

    for (key in o) {
      val = o[key];
      out[key] = clone(val);
    }

    return out;
  }

  var popupStyles = ".cw-popup{position:relative}.cw-popup.shown{z-index:1}.cw-popup-overlay{position:fixed;top:0;bottom:0;left:0;right:0}.cw-popup-content{float:left;position:relative;margin:12px 0 18px;background:#fff;box-sizing:border-box;border-radius:3px;border:1px solid #ddd;box-shadow:var(--boxShadow)}.cw-popup-arrow{position:absolute;bottom:100%;transform:translateX(-7px)}.cw-popup-arrow:before,.cw-popup-arrow:after{content:'';position:absolute;bottom:100%;width:0;height:0;border:8px solid transparent;border-bottom-color:#bbb}.cw-popup-arrow:after{border:7px solid transparent;border-bottom-color:#fff;left:1px}\n";

  var styles = ".gl-row{display:flex}.gl-row .col-1{width:8.33333%}.gl-row .col-2{width:16.66667%}.gl-row .col-3{width:25%}.gl-row .col-4{width:33.33333%}.gl-row .col-5{width:41.66667%}.gl-row .col-6{width:50%}.gl-row .col-7{width:58.33333%}.gl-row .col-8{width:66.66667%}.gl-row .col-9{width:75%}.gl-row .col-10{width:83.33333%}.gl-row .col-11{width:91.66667%}.gl-row .col-12{width:100%}.customize-control img,.customize-control svg{display:block}.customize-control select:focus,.customize-control input[type=\"text\"]:focus,.customize-control input[type=\"password\"]:focus,.customize-control input[type=\"color\"]:focus,.customize-control input[type=\"date\"]:focus,.customize-control input[type=\"datetime\"]:focus,.customize-control input[type=\"datetime-local\"]:focus,.customize-control input[type=\"email\"]:focus,.customize-control input[type=\"month\"]:focus,.customize-control input[type=\"number\"]:focus,.customize-control input[type=\"search\"]:focus,.customize-control input[type=\"tel\"]:focus,.customize-control input[type=\"time\"]:focus,.customize-control input[type=\"url\"]:focus,.customize-control input[type=\"week\"]:focus,.customize-control textarea:focus{border-color:var(--accent);color:var(--accentDark);box-shadow:inset 0 0 0 1px var(--accent)}.customize-control select{border-color:var(--border);background-size:12px 12px}.customize-control select:hover{color:var(--accentDark)}.customize-control input[type=\"text\"],.customize-control input[type=\"password\"],.customize-control input[type=\"color\"],.customize-control input[type=\"date\"],.customize-control input[type=\"datetime\"],.customize-control input[type=\"datetime-local\"],.customize-control input[type=\"email\"],.customize-control input[type=\"month\"],.customize-control input[type=\"number\"],.customize-control input[type=\"search\"],.customize-control input[type=\"tel\"],.customize-control input[type=\"time\"],.customize-control input[type=\"url\"],.customize-control input[type=\"week\"],.customize-control select,.customize-control textarea{border-color:var(--border)}.customize-control input[type=\"radio\"]{border:1px solid var(--border);box-shadow:none}.customize-control input[type=\"radio\"]:checked{border-color:var(--accent);background:var(--accent)}.customize-control input[type=\"radio\"]:checked:before{background:#fff !important}.customize-control-checkbox .customize-inside-control-row{margin-left:0}.customize-control-checkbox input[type=\"checkbox\"]{float:right;width:38px;height:20px;border-radius:20px;border:1px solid rgba(0,0,0,0.2);background:#dadbdd;margin:0;transition:all .2s;position:relative}.customize-control-checkbox input[type=\"checkbox\"]:checked{background:var(--accent);border:1px solid rgba(0,0,0,0.1)}.customize-control-checkbox input[type=\"checkbox\"]:before{content:'';position:absolute;display:block;margin:0;width:6px;height:6px;top:50%;right:6px;border-radius:50px;border:1px solid #b4b4b4;transform:translateY(-50%)}.customize-control-checkbox input[type=\"checkbox\"]:checked:before{content:'';background:rgba(255,255,255,0.5);width:1px;height:8px;display:block;left:10px;border:none}.customize-control-checkbox input[type=\"checkbox\"]:after{content:'';position:absolute;background:#fff;width:16px;height:16px;display:block;border-radius:10px;margin:1px;box-shadow:0 0 2px #666;transition:transform 0.2s cubic-bezier(0.175, 0.885, 0.32, 1.175)}.customize-control-checkbox input[type=\"checkbox\"]:checked:after{transform:translateX(18px)}.customize-control-checkbox input[type=\"checkbox\"]:focus{box-shadow:0 0 0 1px var(--accent);border-color:var(--accent)}.customize-control-multicheck input{border:1px solid var(--border);box-shadow:none;margin-right:.5rem}.customize-control-multicheck input:checked{border-color:var(--accent);background:var(--accent)}.customize-control-multicheck input:checked:before{content:'';width:8px;height:4px;border:2px solid #fff;border-top:none;border-right:none;transform:rotate(-45deg);margin:0.12rem 0 0 0.12rem}.customize-section-sidebar .customize-section-title{position:relative}.control-section-sidebar .back-to-layout{position:absolute;left:0;top:0}#customize-theme-controls .control-section.customize-pane-child.open{height:100%}#accordion-section-title_tagline h3:before,#accordion-panel-layout h3:before,#accordion-panel-blog h3:before,#accordion-section-performance h3:before,#accordion-section-presets h3:before,#accordion-section-extra_styles h3:before{content:'';width:4px;height:4px;position:absolute;right:6px;top:calc(50% - 2px);background:var(--accent);border-radius:50%}#accordion-section-framework{margin-bottom:15px}#accordion-section-header_section.control-section{border-top:1px solid #ddd}.gl-radio-images{font-size:0;margin-bottom:0;line-height:0;display:flex;flex-wrap:wrap;justify-content:space-between;column-gap:5px}.gl-radio-image{max-width:calc(25% - 10px);padding:10px 0;box-sizing:border-box}.gl-radio-image label{display:block;position:relative}.gl-radio-image input[type=\"radio\"]{position:absolute;width:0;height:0;opacity:0}.gl-radio-image input[type=\"radio\"]+.icon{color:#fff;background:#c4c8ca;transition:all 0.1s}.gl-radio-image input[type=\"radio\"]:checked+.icon,.gl-radio-image input[type=\"radio\"]:focus+.icon{color:var(--accent);background:#fff}.gl-radio-image input[type=\"radio\"]:not(:checked):hover+.icon{color:#fff;background:var(--accent)}.gl-radio-image svg{width:100%;height:auto}.gl-radio-image input[type=\"radio\"]:checked+img{outline:3px solid var(--accent)}.gl-radio-image input[type=\"radio\"]:focus+img{outline:3px solid var(--accent)}.gl-radio-image label .preset-name{display:block;line-height:1.2;font-size:11px;padding-top:8px;text-align:center}.gl-radio-image .template-name{position:absolute;width:100%;height:10px;line-height:1;font-size:10px;text-align:center;top:-13px;visibility:hidden}.gl-radio-image:hover .template-name{visibility:visible}.customize-control-template-sequence .gl-radio-image{max-width:62px}.customize-control-template-sequence .icon svg{height:40px}.customize-control-template-sequence .icon rect{height:42px;y:-13}.customize-control-template .gl-radio-image input[type=\"radio\"]:checked+img{outline:3px solid var(--accent)}.customize-control-template .more-wrap input[type=\"checkbox\"]{background:none;border:none;box-shadow:none;width:100%;margin:0 0 10px;padding:0 5px !important;text-align:right;font-size:13px}.customize-control-template .more-wrap input[type=\"checkbox\"]:before{content:'More options';color:#0277BD;display:block;height:1rem;line-height:1rem;padding:0;width:100%;margin:0}.customize-control-template .more-wrap input[type=\"checkbox\"]:checked:before{content:'Less options'}.customize-control-template .more-wrap input[type=\"checkbox\"]:checked+.more-content{max-height:200px}.customize-control-template .more-content{padding:2px 1px;max-height:0;overflow:hidden;transition:max-height 0.3s ease-out}.customize-control-preset .gl-radio-image{max-width:calc(33.3% - 15px);padding:12px 0}.greenlet-divider{border-top:2px solid #dadada;border-bottom:2px solid #f7f7f7;margin:10px -12px}.cover-layout button{cursor:pointer;border-radius:3px;background:none}.cover-layout button:focus{outline:none;border-color:var(--accent);box-shadow:inset 0 0 0 1px var(--accent)}.cover-layout .row{margin-left:-12px;margin-right:-12px}.cover-layout .row-title{background:#fff;padding:8px 10px;border-left:2px solid transparent;transition:all .15s ease-in-out, border-color .15s ease-in-out, background .15s ease-in-out;box-shadow:0 0 0 1px #ddd;position:relative;cursor:pointer}.cover-layout .row-content{padding:0 12px;border-bottom:1px solid #ddd;max-height:0;overflow-y:auto;box-sizing:border-box;transition:.5s all;opacity:0.2}.cover-layout .expanded .row-content{padding:8px 12px 14px;max-height:500px;opacity:1}.cover-layout .add-button{background:#fff;width:20px;height:20px;border-radius:20px;margin:auto;padding:2px;border:1px solid #ccc}.cover-layout .dashicons{font-size:14px;width:auto;height:auto;vertical-align:text-top}.cover-layout .add-wrap{padding:6px;text-align:center}.cover-layout .add-wrap .add-button{display:block}.cover-layout .make-primary{display:inline-flex;border:1px solid transparent;border-radius:10px;color:#999;height:20px;width:20px;padding:2px 0 0 0;margin-left:10px;justify-content:center}.cover-layout .make-primary .dashicons{font-size:13px}.cover-layout .toggler{display:flex;float:right;border:1px solid transparent;border-radius:9px;color:#999;padding:0;height:18px;width:18px;transition:.2s transform}.cover-layout .toggler .dashicons{line-height:16px}.cover-layout .row.expanded .toggler{transform:rotateZ(-180deg)}.cover-layout .layout-control{margin-bottom:12px;align-items:center}.cover-layout .layout-control .title{display:block;margin-bottom:5px}.cover-layout .layout-control-items{box-shadow:0 0 2px rgba(0,0,0,0.4);border-radius:3px;background:#fff}.cover-layout .cols-title{padding:5px}.cover-layout .cover-layout-col{min-height:30px;border-top:1px solid #eee}.cover-layout .cover-layout-col .add-button{background:var(--accent);color:#fff;border-color:transparent;margin:2px 0 2px}.cover-layout .cover-layout-col .add-button:focus{box-shadow:0 0 0 2px #027cba}.cover-layout .col-name,.cover-layout .col-items,.cover-layout .col-items .sortable{padding:5px;display:flex;flex-wrap:wrap;column-gap:10px;row-gap:10px}.cover-layout .col-items .sortable{padding:0}.cover-layout .col-name{border-right:1px solid #f9f9f9}.cover-layout .cw-popup{display:inline-block;max-width:20px}.cover-layout .layout-item{border:1px solid transparent;border-bottom-color:#f2f2f2;border-radius:0;padding:10px 20px;width:100%;text-align:left;color:#0071a1}.cover-layout .layout-item:hover{background:var(--accentLight)}.cover-layout .layout-item:last-child{border-bottom-color:transparent}.cover-layout .open.col-item{margin-right:0;width:100%}.cover-layout .open>.item-id{width:100%;padding-right:24px;border-radius:3px 3px 0 0}.cover-layout .open .item-x{display:inline-block}.cover-layout .item-props{background:var(--accentLight);border:1px solid rgba(0,0,0,0.2);border-top:none;box-shadow:0 6px 10px rgba(0,0,0,0.1)}.cover-layout .item-props .item-prop{display:flex;margin-bottom:8px}.cover-layout .item-props .item-prop.hidden{display:none}.cover-layout .item-props .prop-title{width:25%;font-size:12px}.cover-layout .item-props input.prop-control{width:75%;min-height:26px;height:26px;font-size:13px}.cover-layout .item-props>button{background:#fff;border:1px solid #c4c8ca;padding:2px 6px}.cover-layout .item-props>button:focus{border-color:var(--accent)}.cover-layout .empty-message{text-align:center;padding:5px;margin-bottom:8px}.cover-layout select{margin:0}.cover-layout .row-footer{display:flex;justify-content:space-between;margin-top:10px}.cover-layout .delete{--accent: #a00;color:#a00;border:1px solid #c4c8ca;padding:2px 6px}.cover-layout .advanced{max-height:0;overflow-y:hidden;transition:0.5s all}.cover-layout .advanced.open{max-height:500px}.cover-layout .advanced-toggle{text-align:right;position:relative}.cover-layout .advanced-toggle span{padding-right:5px}.cover-layout .advanced-toggle .check{position:absolute;right:0;top:0;width:110px;height:22px;background:none;margin:0;box-shadow:none;border-color:#c4c8ca}.cover-layout .advanced-toggle .check:checked::before{content:''}.cover-layout .advanced-toggle .check:focus{border-color:var(--accent);box-shadow:0 0 0 1px var(--accent)}.cover-layout .expandable{opacity:0;max-height:0;max-width:0;overflow:hidden;transition:.2s all;padding:0 5px}.cover-layout .open>.expandable{opacity:1;overflow:auto;max-height:1000px;max-width:100%;padding:8px 5px 0 5px}.cover-layout .select-search__input{height:26px;font-size:13px}.cover-layout .select-search__row{margin:0}.cover-layout .select-search__option{height:24px;line-height:24px;font-size:13px;border-radius:0}.gl-sort-clone{z-index:999500}.gl-col-item{display:inline-block;position:relative}.gl-col-item .item-id{display:inline-flex;background:var(--accent);color:#fff;border:none;cursor:pointer;box-sizing:border-box;border-radius:3px}.gl-col-item .item-id span{padding:5px 6px 6px 0;line-height:1}.gl-col-item .item-id .drag-handle{cursor:move;padding-left:6px}.gl-col-item .item-x{position:absolute;right:2px;top:2px;width:20px;height:20px;background:#fff;color:#D84315;padding:2px 0 0 2px;cursor:pointer;box-sizing:border-box;text-align:center;display:none;border:none;border-radius:2px}.gl-col-item .item-x:focus{box-shadow:0 0 0 2px #027cba;color:#D84315}.gl-col-item.gl-sort-clone .item-props{display:none}.gl-ext-link{margin-bottom:1px}.gl-ext-link a{padding:10px 10px 11px 14px;background:#fff;border-left:4px solid #fff;transition:.15s color ease-in-out, .15s background-color ease-in-out, .15s border-color ease-in-out;box-shadow:0 0 0 1px var(--accent);display:block;font-size:14px;font-weight:600;text-decoration:none;position:relative;line-height:1.55}.gl-ext-link a:hover,.gl-ext-link a:focus{background:#f3f3f5;border-left-color:#0073aa}.gl-ext-link a:hover:after,.gl-ext-link a:focus:after{color:#0073aa}.gl-ext-link a:after{content:'\\f345';font:normal 20px/1 dashicons;color:#a0a5aa;position:absolute;right:10px;top:calc(50% - 10px);-webkit-font-smoothing:antialiased;-moz-osx-font-smoothing:grayscale}.gl-ext-link.control{width:100%;float:left;clear:both;margin-top:12px;margin-bottom:12px}.gl-ext-link.control a{border-left-width:2px;padding:6px 10px;font-size:13px;font-weight:500}.gl-ext-link.control a:after{content:\"\\f504\";font:normal 16px/1 dashicons;top:calc(50% - 8px)}.gl-sequence{margin:14px 0 28px}.gl-sequence-col{padding-top:0;position:relative}.gl-sequence-col:not(:last-child) select{border-right-width:0}.gl-sequence-col:first-child select{border-radius:3px 0 0 3px}.gl-sequence-col:last-child select{border-radius:0 3px 3px 0}.gl-sequence-col:only-child select{border-radius:3px}.gl-sequence-col select{width:100%;margin:0;font-size:12px}.gl-sequence-col select:focus{border-right-width:1px}.gl-sequence-name{position:absolute;top:110%;left:-1px;font-size:10px;color:#aaa;width:calc( 100% + 2px);text-align:center;overflow:hidden}.gl-sequence-name svg.gl-arrow{position:absolute;left:0;top:4px}.gl-sequence-name svg.gl-arrow.right{transform:rotateZ(180deg);right:0;left:auto}.gl-sequence-name>span{background:#eee;position:relative;padding:0 4px}.gl-border{display:flex;align-items:flex-start;flex-wrap:wrap;justify-content:flex-end}.gl-border .width-wrap{flex-grow:1;height:30px;line-height:25px}.customize-control-border input[type=\"range\"]{width:95%}.customize-control-border select{width:111px;margin-right:5px;margin-bottom:10px}.aspect{position:absolute;left:40%;top:115%;color:#999;font-size:18px;cursor:pointer;display:inline-block;z-index:10}.lock-indicator{position:absolute;left:calc(40% + 10px);height:50px;border-right:1px dashed #ccc;top:45px;transition:.2s all;transform:scale(1)}.dashicons-unlock ~ .lock-indicator{transform:scale(0)}.aspect:before{background:#eee}.customize-control-cover-layout .notice{max-height:0;padding:0;overflow:hidden;animation:.4s forwards ease grow}@keyframes grow{100%{max-height:200px;padding:9px 14px}}.gl-doc-link{position:absolute;top:13px;right:1px;text-decoration:none;padding:10px}.gl-doc-link .dashicons{color:#555e66;font-size:16px}.gl-doc-link .tip{position:absolute;bottom:calc(100% - 10px);right:10px;background:#000;color:#fff;padding:2px 6px;border-radius:3px;opacity:0;transition:.2s all}.gl-doc-link:hover .dashicons{color:#006799}.gl-doc-link:hover .tip{opacity:1}.gl-sorter .group{position:relative;padding:5px 0}.gl-sorter .group.top:before,.gl-sorter .group.middle:before,.gl-sorter .group.bottom:before{content:'';width:calc(100% + 10px);height:100%;position:absolute;top:0;left:-6px;border:1px dashed #bbb;border-top-color:transparent;border-bottom-color:transparent}.gl-sorter .group.top{padding-top:22px}.gl-sorter .group.top:before{border-top-color:#bbb}.gl-sorter .group.top:after{content:'CARD';top:0;left:0;position:absolute;font-size:8px;font-weight:600;color:#999}.gl-sorter .group.bottom{padding-bottom:8px}.gl-sorter .group.bottom:before{border-bottom-color:#bbb}.gl-sorter .group.above,.gl-sorter .group.below{padding:20px 0 10px}.gl-sorter .group-inner{background:#e6e6e6;padding:1px 5px 5px 0;min-height:44px;box-sizing:border-box;position:relative}.gl-sorter .group-title{position:absolute;left:50%;top:-8px;font-size:8px;line-height:14px;background:#e6e6e6;padding:0 10px;text-transform:uppercase;font-weight:600;color:#999;transform:translateX(-50%);border-radius:50%}.gl-sorter .item{border:1px solid #c4c8ca;margin:5px 0 0 5px;background:#fff}.gl-sorter .hidden-item{opacity:.6;transition:.2s opacity}.gl-sorter .hidden-item:hover{opacity:1}.gl-sorter .handle{padding:12px;display:inline-block;line-height:.7;font-size:16px;cursor:move}.gl-sorter .title{font-weight:500}.gl-sorter button{float:right;padding:8px 6px 5px;background:none;border:1px solid transparent;border-left-color:#eee;color:#565f67;cursor:pointer}.gl-sorter button:focus{outline:none;border-color:var(--accent);box-shadow:inset 0 0 0 1px var(--accent)}.gl-sorter .dashicons{font-size:16px}.gl-sorter .dashicons:after{opacity:0;margin-left:-4px}.gl-sorter .dashicons-visibility:after{content:'\\f530'}.gl-sorter .dashicons-hidden:after{content:'\\f177'}.gl-sorter button:hover .dashicons-visibility:before,.gl-sorter button:hover .dashicons-hidden:before{font-size:0;opacity:0}.gl-sorter button:hover .dashicons-visibility:after,.gl-sorter button:hover .dashicons-hidden:after{opacity:1}.gl-sorter .toggler .dashicons{font-size:14px;line-height:20px;transition:.2s transform}.gl-sorter .toggler.open .dashicons{transform:rotateZ(-180deg)}.gl-sorter .item-meta{display:none}.gl-sorter .item-meta.open{display:block}.gl-sorter .item-meta label{display:block;padding:6px 0}.gl-sorter .item-meta label span{margin-left:4px}.gl-sorter .meta-control{padding:10px;border-top:1px solid #ddd}.gl-sorter .control-label{font-weight:500;margin-bottom:6px}.gl-sorter .control-description{margin-bottom:6px}\n";

  $(window).on('load', function () {
    $('html').addClass('window-loaded');
  });
  var extUrl = 'https://greenletwp.com';
  var style = document.createElement('style');
  style.id = 'greenlet-controls';
  style.innerHTML = "".concat(popupStyles, " ").concat(styles);
  document.body.appendChild(style);

  var insertExtLinks = function insertExtLinks() {
    if (['1', 'true', true].includes(glControlData.ext)) return;
    var items = [{
      id: 'accordion-section-title_tagline',
      place: 'before',
      type: 'section',
      tagName: 'li'
    }, {
      id: 'sub-accordion-section-blog_extra',
      place: 'append',
      type: 'control',
      tagName: 'li'
    }, {
      id: 'customize-control-post_list_layout',
      place: 'append',
      type: 'control'
    }, {
      id: 'customize-control-css_framework',
      place: 'append',
      type: 'control'
    }];
    var markUp = "<a href=\"".concat(extUrl, "/pro\" target=\"_blank\"><span>").concat(glControlData.extText, "</span></a>");
    items.forEach(function (item) {
      var el = document.getElementById(item.id);
      if (null === el) return;
      var link = document.createElement(item.tagName || 'div');
      link.classList.add('gl-ext-link');
      link.innerHTML = markUp;

      if ('control' === item.type) {
        link.classList.add('control');
      }

      if ('before' === item.place) {
        el.insertAdjacentElement('beforebegin', link);
      } else if ('append' === item.place) {
        el.appendChild(link);
      }
    });
  };

  var insertDocLinks = function insertDocLinks() {
    var __ = wp.i18n.__;
    var items = [{
      id: 'sub-accordion-section-title_tagline',
      link: 'customize/logo-title-tagline/'
    }, {
      id: 'sub-accordion-section-framework',
      link: 'customize/css-framework/'
    }, {
      id: 'sub-accordion-section-header_section',
      link: 'customize/header-footer-builder/'
    }, {
      id: 'sub-accordion-section-footer_section',
      link: 'customize/header-footer-builder/'
    }, {
      id: 'sub-accordion-section-main_layout',
      link: 'customize/page-layout/'
    }, {
      id: 'sub-accordion-section-blog_list',
      link: 'customize/post-list-design/'
    }, {
      id: 'sub-accordion-section-blog_single',
      link: 'customize/single-post-design/'
    }, {
      id: 'sub-accordion-section-blog_page',
      link: 'customize/single-page-design/'
    }, {
      id: 'sub-accordion-section-performance',
      link: 'customize/performance/'
    }, {
      id: 'sub-accordion-section-presets',
      link: 'customize/presets/'
    }, {
      id: 'sub-accordion-section-extra_styles',
      link: 'customize/colorwings-visual-style-editor/'
    }];
    items.forEach(function (item) {
      var el = document.querySelector("#".concat(item.id, " .customize-section-title"));
      if (null === el) return;
      var link = document.createElement('a');
      link.classList.add('gl-doc-link');
      link.href = "".concat(extUrl, "/docs/").concat(item.link);
      link.target = '_blank';
      link.innerHTML = "<span class=\"dashicons dashicons-book\"></span><span class=\"tip\">".concat(__('Documentation', 'greenlet'), "</span>");
      el.insertAdjacentElement('beforeend', link);
    });
  };

  wp.customize.bind('ready', function () {
    insertExtLinks();
    insertDocLinks();
  });

  /**
   * Multicheck Control.
   *
   * @package greenlet
   */
  wp.customize.controlConstructor['multicheck'] = wp.customize.Control.extend({
    ready: function ready() {
      var control = this;
      var checkboxes = $(control.selector + ' input[type="checkbox"]');
      checkboxes.on('change', function () {
        var val = Array.from(control.setting._value);
        var current = $(this).val();
        var index = val.indexOf(current);

        if ($(this).prop('checked')) {
          if (index === -1) {
            val.push(current);
          }
        } else {
          if (index !== -1) {
            val.splice(index, 1);
          }
        }

        control.setting.set(val);
      });
    }
  });

  /**
   * Radio Image Control.
   *
   * @package greenlet
   */
  wp.customize.controlConstructor['radio-image'] = wp.customize.Control.extend({
    ready: function ready() {
      var control = this;
      var radios = $(control.selector + ' input[type="radio"]');
      radios.on('change', function () {
        control.setting.set(this.value);
      });
    }
  });

  /**
   * Template Control.
   *
   * @package greenlet
   */
  wp.customize.controlConstructor['template'] = wp.customize.Control.extend({
    ready: function ready() {
      var control = this;
      var radios = $(control.selector + ' input[type="radio"]');
      var rawInput = $(control.selector + ' #' + control.id + '-text');

      var setValue = function setValue(value, element) {
        if (element === 'input') {
          rawInput.val(value);
        } else if (element === 'radios') {
          radios.val([value]);
        }

        control.setting.set(value);
      };

      rawInput.on('input', debounce(function () {
        setValue(this.value, 'radios');
      }, 500));
      radios.on('change', function () {
        setValue(this.value, 'input');
      });
    }
  });

  /**
   * Template Selector Control.
   *
   * @package greenlet
   */
  wp.customize.controlConstructor['template-sequence'] = wp.customize.Control.extend({
    ready: function ready() {
      var __ = wp.i18n.__;
      var control = this;
      var radios = $(control.selector + ' input[type="radio"]');
      var val = control.setting._value;
      var template = val.template; // Listen to Template selection change.

      radios.on('change', function () {
        template = $(this).val();
        var cols = template.split('-');
        var colsLength = cols.length;
        var matcherHtml = '';
        var sequence = ['main'];
        var sidebars = $('#_customize-input-sidebars_qty').val();

        for (var i = 1; i <= colsLength; i++) {
          matcherHtml += '<div class="gl-sequence-col col-' + cols[i - 1] + '">';
          matcherHtml += '<select class="gl-sequence-content">';
          var selected = i === 1 ? 'selected' : '';
          matcherHtml += "<option value=\"main\" ".concat(selected, ">").concat(__('Main Content', 'greenlet'), "</option>");

          for (var j = 1; j <= sidebars; j++) {
            selected = i === j + 1 ? 'selected' : '';
            matcherHtml += "<option value=\"sidebar-".concat(j, "\" ").concat(selected, ">").concat(__('Sidebar', 'greenlet'), " ").concat(j, "</option>");
          }

          matcherHtml += '</select>';
          matcherHtml += "<div class=\"gl-sequence-name\">\n\t\t\t\t\t\t\t<svg class=\"gl-arrow left\" width=\"201px\" height=\"11px\" viewBox=\"0 0 201 11\">\n\t\t\t\t\t\t\t\t<use href=\"#gl-arrow-shape\" />\n\t\t\t\t\t\t\t</svg>\n\t\t\t\t\t\t\t<svg class=\"gl-arrow right\" width=\"201px\" height=\"11px\" viewBox=\"0 0 201 11\">\n\t\t\t\t\t\t\t\t<use href=\"#gl-arrow-shape\" />\n\t\t\t\t\t\t\t</svg>\n\t\t\t\t\t\t\t<span>".concat(cols[i - 1], "</span>\n\t\t\t\t\t\t</div>");
          matcherHtml += '</div>';

          if (i < colsLength) {
            sequence.push('sidebar-' + i);
          }
        }

        $('#customize-control-' + control.id).find('.gl-sequence').html(matcherHtml);
        val = {
          template: template,
          sequence: sequence
        };
        control.setting.set(val);
      }); // Listen to Template column sequence change.

      $(control.selector).on('change', '.gl-sequence-content', function () {
        // Update control value.
        var sequence = [];
        $(this).parent().parent().find('select').each(function () {
          sequence.push($(this).val());
        });
        val = {
          template: template,
          sequence: sequence
        };
        control.setting.set(val);
      });
    }
  });

  function createCommonjsModule(fn, basedir, module) {
  	return module = {
  		path: basedir,
  		exports: {},
  		require: function (path, base) {
  			return commonjsRequire(path, (base === undefined || base === null) ? module.path : base);
  		}
  	}, fn(module, module.exports), module.exports;
  }

  function getAugmentedNamespace(n) {
  	if (n.__esModule) return n;
  	var a = Object.defineProperty({}, '__esModule', {value: true});
  	Object.keys(n).forEach(function (k) {
  		var d = Object.getOwnPropertyDescriptor(n, k);
  		Object.defineProperty(a, k, d.get ? d : {
  			enumerable: true,
  			get: function () {
  				return n[k];
  			}
  		});
  	});
  	return a;
  }

  function commonjsRequire () {
  	throw new Error('Dynamic requires are not currently supported by @rollup/plugin-commonjs');
  }

  var prefix = 'Invariant failed';
  function invariant(condition, message) {
      if (condition) {
          return;
      }
      {
          throw new Error(prefix);
      }
  }

  var tinyInvariant_esm = /*#__PURE__*/Object.freeze({
    __proto__: null,
    'default': invariant
  });

  var classnames = createCommonjsModule(function (module) {
  /*!
    Copyright (c) 2017 Jed Watson.
    Licensed under the MIT License (MIT), see
    http://jedwatson.github.io/classnames
  */
  /* global define */

  (function () {

  	var hasOwn = {}.hasOwnProperty;

  	function classNames () {
  		var classes = [];

  		for (var i = 0; i < arguments.length; i++) {
  			var arg = arguments[i];
  			if (!arg) continue;

  			var argType = typeof arg;

  			if (argType === 'string' || argType === 'number') {
  				classes.push(arg);
  			} else if (Array.isArray(arg) && arg.length) {
  				var inner = classNames.apply(null, arg);
  				if (inner) {
  					classes.push(inner);
  				}
  			} else if (argType === 'object') {
  				for (var key in arg) {
  					if (hasOwn.call(arg, key) && arg[key]) {
  						classes.push(key);
  					}
  				}
  			}
  		}

  		return classes.join(' ');
  	}

  	if ( module.exports) {
  		classNames.default = classNames;
  		module.exports = classNames;
  	} else {
  		window.classNames = classNames;
  	}
  }());
  });

  var require$$0 = /*@__PURE__*/getAugmentedNamespace(tinyInvariant_esm);

  var dist = createCommonjsModule(function (module, exports) {
  var e=g(require$$0),t=require$$1__default['default'],n=t.Children,r=t.cloneElement,o=t.Component,i=t.createElement,l=t.createRef,a=g(classnames),c=require$$3__default['default'],s=g(c);exports.Sortable=s;var u=c.Direction;exports.Direction=u;var f=c.DOMRect;exports.DOMRect=f;var p=c.GroupOptions;exports.GroupOptions=p;var d=c.MoveEvent;exports.MoveEvent=d;var b=c.Options;exports.Options=b;var y=c.PullResult;exports.PullResult=y;var v=c.PutResult;exports.PutResult=v;var h=c.SortableEvent;exports.SortableEvent=h;var m=c.SortableOptions;exports.SortableOptions=m;var O=c.Utils;function g(e){return e&&e.__esModule?e.default:e}function w(e,t){if(null==e)return {};var n,r,o=function(e,t){if(null==e)return {};var n,r,o={},i=Object.keys(e);for(r=0;r<i.length;r++)n=i[r],t.indexOf(n)>=0||(o[n]=e[n]);return o}(e,t);if(Object.getOwnPropertySymbols){var i=Object.getOwnPropertySymbols(e);for(r=0;r<i.length;r++)n=i[r],t.indexOf(n)>=0||Object.prototype.propertyIsEnumerable.call(e,n)&&(o[n]=e[n]);}return o}function S(e){return function(e){if(Array.isArray(e))return j(e)}(e)||function(e){if("undefined"!=typeof Symbol&&Symbol.iterator in Object(e))return Array.from(e)}(e)||function(e,t){if(!e)return;if("string"==typeof e)return j(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(e);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return j(e,t)}(e)||function(){throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}function j(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function x(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r);}return n}function I(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{};t%2?x(Object(n),!0).forEach((function(t){P(e,t,n[t]);})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(n)):x(Object(n)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(n,t));}));}return e}function P(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function E(e){null!==e.parentElement&&e.parentElement.removeChild(e);}function k(e){e.forEach((function(e){return E(e.element)}));}function C(e){e.forEach((function(e){var t,n,r,o;t=e.parentElement,n=e.element,r=e.oldIndex,o=t.children[r]||null,t.insertBefore(n,o);}));}function D(e,t){var n=M(e),r={parentElement:e.from},o=[];switch(n){case"normal":o=[{element:e.item,newIndex:e.newIndex,oldIndex:e.oldIndex,parentElement:e.from}];break;case"swap":o=[I({element:e.item,oldIndex:e.oldIndex,newIndex:e.newIndex},r),I({element:e.swapItem,oldIndex:e.newIndex,newIndex:e.oldIndex},r)];break;case"multidrag":o=e.oldIndicies.map((function(t,n){return I({element:t.multiDragElement,oldIndex:t.index,newIndex:e.newIndicies[n].index},r)}));}return function(e,t){return e.map((function(e){return I(I({},e),{},{item:t[e.oldIndex]})})).sort((function(e,t){return e.oldIndex-t.oldIndex}))}(o,t)}function A(e,t){var n=S(t);return e.concat().reverse().forEach((function(e){return n.splice(e.oldIndex,1)})),n}function R(e,t,n,r){var o=S(t);return e.forEach((function(e){var t=r&&n&&r(e.item,n);o.splice(e.newIndex,0,t||e.item);})),o}function M(e){return e.oldIndicies&&e.oldIndicies.length>0?"multidrag":e.swapItem?"swap":"normal"}function U(e){return (U="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e})(e)}function L(e){return function(e){if(Array.isArray(e))return _(e)}(e)||function(e){if("undefined"!=typeof Symbol&&Symbol.iterator in Object(e))return Array.from(e)}(e)||function(e,t){if(!e)return;if("string"==typeof e)return _(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(e);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return _(e,t)}(e)||function(){throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}function _(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function H(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var r=Object.getOwnPropertySymbols(e);t&&(r=r.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,r);}return n}function N(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{};t%2?H(Object(n),!0).forEach((function(t){B(e,t,n[t]);})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(n)):H(Object(n)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(n,t));}));}return e}function q(e,t){for(var n=0;n<t.length;n++){var r=t[n];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(e,r.key,r);}}function T(e,t){return (T=Object.setPrototypeOf||function(e,t){return e.__proto__=t,e})(e,t)}function F(e){var t=function(){if("undefined"==typeof Reflect||!Reflect.construct)return !1;if(Reflect.construct.sham)return !1;if("function"==typeof Proxy)return !0;try{return Date.prototype.toString.call(Reflect.construct(Date,[],(function(){}))),!0}catch(e){return !1}}();return function(){var n,r=$(e);if(t){var o=$(this).constructor;n=Reflect.construct(r,arguments,o);}else n=r.apply(this,arguments);return G(this,n)}}function G(e,t){return !t||"object"!==U(t)&&"function"!=typeof t?function(e){if(void 0===e)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return e}(e):t}function $(e){return ($=Object.setPrototypeOf?Object.getPrototypeOf:function(e){return e.__proto__||Object.getPrototypeOf(e)})(e)}function B(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}exports.Utils=O;var J={dragging:null},z=function(t){!function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Super expression must either be null or a function");e.prototype=Object.create(t&&t.prototype,{constructor:{value:e,writable:!0,configurable:!0}}),t&&T(e,t);}(d,o);var c,u,p=F(d);function d(t){var n;!function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}(this,d),(n=p.call(this,t)).ref=l();var r=t.list.map((function(e){return N(N({},e),{},{chosen:!1,selected:!1})}));return t.setList(r,n.sortable,J),e(!t.plugins,'\nPlugins prop is no longer supported.\nInstead, mount it with "Sortable.mount(new MultiDrag())"\nPlease read the updated README.md at https://github.com/SortableJS/react-sortablejs.\n      '),n}return c=d,(u=[{key:"componentDidMount",value:function(){if(null!==this.ref.current){var e=this.makeOptions();s.create(this.ref.current,e);}}},{key:"render",value:function(){var e=this.props,t=e.tag,n={style:e.style,className:e.className,id:e.id};return i(t&&null!==t?t:"div",N({ref:this.ref},n),this.getChildren())}},{key:"getChildren",value:function(){var e=this.props,t=e.children,o=e.dataIdAttr,i=e.selectedClass,l=void 0===i?"sortable-selected":i,c=e.chosenClass,s=void 0===c?"sortable-chosen":c,u=(e.dragClass,e.fallbackClass,e.ghostClass,e.swapClass,e.filter),f=void 0===u?"sortable-filter":u,p=e.list;if(!t||null==t)return null;var d=o||"data-id";return n.map(t,(function(e,t){var n,o,i=p[t],c=e.props.className,u="string"==typeof f&&B({},f.replace(".",""),!!i.filtered),b=a(c,N((B(n={},l,i.selected),B(n,s,i.chosen),n),u));return r(e,(B(o={},d,e.key),B(o,"className",b),o))}))}},{key:"makeOptions",value:function(){var e,t=this,n=((e=this.props).list,e.setList,e.children,e.tag,e.style,e.className,e.clone,e.onAdd,e.onChange,e.onChoose,e.onClone,e.onEnd,e.onFilter,e.onRemove,e.onSort,e.onStart,e.onUnchoose,e.onUpdate,e.onMove,e.onSpill,e.onSelect,e.onDeselect,w(e,["list","setList","children","tag","style","className","clone","onAdd","onChange","onChoose","onClone","onEnd","onFilter","onRemove","onSort","onStart","onUnchoose","onUpdate","onMove","onSpill","onSelect","onDeselect"]));return ["onAdd","onChoose","onDeselect","onEnd","onRemove","onSelect","onSpill","onStart","onUnchoose","onUpdate"].forEach((function(e){return n[e]=t.prepareOnHandlerPropAndDOM(e)})),["onChange","onClone","onFilter","onSort"].forEach((function(e){return n[e]=t.prepareOnHandlerProp(e)})),N(N({},n),{},{onMove:function(e,n){var r=t.props.onMove,o=e.willInsertAfter||-1;if(!r)return o;var i=r(e,n,t.sortable,J);return void 0!==i&&i}})}},{key:"prepareOnHandlerPropAndDOM",value:function(e){var t=this;return function(n){t.callOnHandlerProp(n,e),t[e](n);}}},{key:"prepareOnHandlerProp",value:function(e){var t=this;return function(n){t.callOnHandlerProp(n,e);}}},{key:"callOnHandlerProp",value:function(e,t){var n=this.props[t];n&&n(e,this.sortable,J);}},{key:"onAdd",value:function(e){var t=this.props,n=t.list,r=t.setList,o=t.clone,i=D(e,L(J.dragging.props.list));k(i),r(R(i,n,e,o).map((function(e){return N(N({},e),{},{selected:!1})})),this.sortable,J);}},{key:"onRemove",value:function(t){var n=this,r=this.props,o=r.list,i=r.setList,l=M(t),a=D(t,o);C(a);var c=L(o);if("clone"!==t.pullMode)c=A(a,c);else {var s=a;switch(l){case"multidrag":s=a.map((function(e,n){return N(N({},e),{},{element:t.clones[n]})}));break;case"normal":s=a.map((function(e){return N(N({},e),{},{element:t.clone})}));break;case"swap":default:e(!0,'mode "'.concat(l,'" cannot clone. Please remove "props.clone" from <ReactSortable/> when using the "').concat(l,'" plugin'));}k(s),a.forEach((function(e){var r=e.oldIndex,o=n.props.clone(e.item,t);c.splice(r,1,o);}));}i(c=c.map((function(e){return N(N({},e),{},{selected:!1})})),this.sortable,J);}},{key:"onUpdate",value:function(e){var t=this.props,n=t.list,r=t.setList,o=D(e,n);return k(o),C(o),r(function(e,t){return R(e,A(e,t))}(o,n),this.sortable,J)}},{key:"onStart",value:function(){J.dragging=this;}},{key:"onEnd",value:function(){J.dragging=null;}},{key:"onChoose",value:function(e){var t=this.props,n=t.list;(0, t.setList)(n.map((function(t,n){return n===e.oldIndex?N(N({},t),{},{chosen:!0}):t})),this.sortable,J);}},{key:"onUnchoose",value:function(e){var t=this.props,n=t.list;(0, t.setList)(n.map((function(t,n){return n===e.oldIndex?N(N({},t),{},{chosen:!1}):t})),this.sortable,J);}},{key:"onSpill",value:function(e){var t=this.props,n=t.removeOnSpill,r=t.revertOnSpill;n&&!r&&E(e.item);}},{key:"onSelect",value:function(e){var t=this.props,n=t.list,r=t.setList,o=n.map((function(e){return N(N({},e),{},{selected:!1})}));e.newIndicies.forEach((function(t){var n=t.index;if(-1===n)return console.log('"'.concat(e.type,'" had indice of "').concat(t.index,"\", which is probably -1 and doesn't usually happen here.")),void console.log(e);o[n].selected=!0;})),r(o,this.sortable,J);}},{key:"onDeselect",value:function(e){var t=this.props,n=t.list,r=t.setList,o=n.map((function(e){return N(N({},e),{},{selected:!1})}));e.newIndicies.forEach((function(e){var t=e.index;-1!==t&&(o[t].selected=!0);})),r(o,this.sortable,J);}},{key:"sortable",get:function(){var e=this.ref.current;if(null===e)return null;var t=Object.keys(e).find((function(e){return e.includes("Sortable")}));return t?e[t]:null}}])&&q(c.prototype,u),d}();exports.ReactSortable=z,B(z,"defaultProps",{clone:function(e){return e}});

  });

  function Popup(props) {
    var _React$useState = React.useState({
      show: false,
      style: {
        content: {
          top: 0
        },
        arrow: {
          right: 0
        }
      }
    }),
        _React$useState2 = _slicedToArray(_React$useState, 2),
        popState = _React$useState2[0],
        setPopState = _React$useState2[1];

    props.onClose(function () {
      setPopState(function (prev) {
        return _objectSpread2(_objectSpread2({}, prev), {}, {
          show: false
        });
      });
    });

    var popupNow = function popupNow(e) {
      var widthSelector = props.widthSelector;

      if (undefined === widthSelector) {
        widthSelector = '.customize-control';
      }

      var widthEl = e.target.closest(widthSelector);
      var elRect;

      if (null !== widthEl) {
        elRect = widthEl.getBoundingClientRect();
      } else {
        elRect = document.body.getBoundingClientRect();
      }

      var clientRect = e.target.getBoundingClientRect();
      var parentRect = e.target.offsetParent.getBoundingClientRect();
      var content = {
        marginLeft: elRect.left - parentRect.left,
        width: elRect.width
      };
      var arrow = {
        left: clientRect.left - elRect.left + clientRect.width / 2
      };
      setPopState(function (prevPopState) {
        return {
          show: !prevPopState.show,
          style: {
            content: content,
            arrow: arrow
          }
        };
      });
    };

    return /*#__PURE__*/React.createElement("div", {
      className: "cw-popup ".concat(popState.show ? 'shown' : '')
    }, /*#__PURE__*/React.createElement("button", {
      className: "cw-popup-button ".concat(props.className),
      onClick: popupNow,
      type: "button"
    }, props.children[0]), /*#__PURE__*/React.createElement("div", {
      className: "cw-popup-overlay ".concat(popState.show ? '' : 'hidden'),
      onClick: function onClick() {
        return setPopState(function (prev) {
          return _objectSpread2(_objectSpread2({}, prev), {}, {
            show: false
          });
        });
      }
    }), /*#__PURE__*/React.createElement("div", {
      className: "cw-popup-content ".concat(popState.show ? '' : 'hidden'),
      style: popState.style.content
    }, /*#__PURE__*/React.createElement("div", {
      className: "cw-popup-arrow",
      style: popState.style.arrow
    }), props.children[1]));
  }

  function RowItems(_ref) {
    var props = _ref.props;
    var __ = wp.i18n.__;
    var row = props.row,
        i = props.i,
        pos = props.pos,
        updateRows = props.updateRows,
        control = props.control;
    var items = control.params.items;
    var cols = row.columns.split('-');

    var _React$useState = React.useState(-1),
        _React$useState2 = _slicedToArray(_React$useState, 2),
        expanded = _React$useState2[0],
        setExpanded = _React$useState2[1];

    var closePop = function closePop() {};

    var onClose = function onClose(cb) {
      closePop = cb;
    };

    var openSidebar = function openSidebar(col) {
      var sidebar = "".concat(pos.toLowerCase(), "-sidebar-").concat(i + 1, "-").concat(col);
      var section = wp.customize.section("sidebar-widgets-".concat(sidebar));

      if (section === undefined) {
        control.notifications.remove('updateWidgets');
        var notification = new wp.customize.Notification('updateWidgets', {
          message: __('Please save and refresh this page to reflect the newly added Widget areas', 'greenlet'),
          type: 'warning'
        });
        control.notifications.add('updateWidgets', notification);
        return;
      }

      section.expand({
        duration: 0
      });
      var parent = document.querySelector("#sub-accordion-section-sidebar-widgets-".concat(sidebar, " .customize-section-title"));
      var btn = document.createElement('button');
      btn.classList.add('customize-section-back', 'back-to-layout');
      btn.type = 'button';
      btn.innerHTML = '<span class="screen-reader-text">Back</span>';
      parent.insertBefore(btn, parent.getElementsByTagName('h3')[0]);

      btn.onclick = function () {
        var backSection = wp.customize.section("".concat(pos.toLowerCase(), "_section"));
        backSection.expand();
        btn.remove();
      };
    };

    var onClickItem = function onClickItem(item, col, k) {
      setExpanded(function (prev) {
        return prev === "".concat(col, "-").concat(k) ? -1 : "".concat(col, "-").concat(k);
      });
    };

    var addItem = function addItem(col, item) {
      updateRows(function (prev) {
        var formatted = {
          id: item.id
        };

        if ('meta' in item) {
          var meta = {};

          for (var propKey in item.meta) {
            if ('items' in item.meta[propKey]) {
              var keys = Object.keys(item.meta[propKey].items);
              meta[propKey] = keys.length > 0 ? keys[0] : '';
            }
          }

          formatted.meta = meta;
        }

        if ('items' in prev[i]) {
          if (col in prev[i].items) {
            prev[i].items[col].push(formatted);
          } else {
            prev[i].items[col] = [formatted];
          }
        } else {
          prev[i].items = _defineProperty({}, col, [formatted]);
        }

        return prev;
      });
      closePop();
    };

    var removeItem = function removeItem(col, k) {
      updateRows(function (prev) {
        prev[i].items[col].splice(k, 1);
        return prev;
      });
    };

    var ColItemProps = function ColItemProps(_ref2) {
      var col = _ref2.col,
          index = _ref2.index,
          item = _ref2.item;

      if (item === 'widgets') {
        return /*#__PURE__*/React.createElement("div", {
          className: "item-props expandable"
        }, /*#__PURE__*/React.createElement("button", {
          type: "button",
          className: "item-prop",
          onClick: function onClick() {
            return openSidebar(col);
          }
        }, __('Add/Edit widgets', 'greenlet')));
      }

      var meta = item in items && 'meta' in items[item] ? items[item].meta : false;
      var currentMeta = row.items[col][index].meta;
      var hasQuery = currentMeta && 'target' in currentMeta && 'query' !== currentMeta.target;

      var _onChange = function onChange(val, propKey) {
        updateRows(function (prev) {
          var colItem = prev[i].items[col][index];

          if (_typeof(colItem) === 'object' && 'meta' in colItem) {
            prev[i].items[col][index].meta[propKey] = val;
          } else {
            prev[i].items[col][index] = {
              id: item,
              meta: _defineProperty({}, propKey, val)
            };
          }

          return prev;
        });
      };

      var debouncedChange = debounce(_onChange, 500);
      var Select = cw.components.Select;

      var renderProp = function renderProp(propKey, prop) {
        var defaultValue = currentMeta !== undefined ? currentMeta[propKey] : '';

        if ('select' === prop.type) {
          var forwardProps = {
            options: Object.entries(prop.items).map(function (_ref3) {
              var _ref4 = _slicedToArray(_ref3, 2),
                  value = _ref4[0],
                  name = _ref4[1];

              return {
                name: name,
                value: value
              };
            }),
            val: defaultValue,
            onChange: function onChange(val) {
              return _onChange(val, propKey);
            }
          };

          if (forwardProps.options.length === 0 && 'empty' in prop) {
            return /*#__PURE__*/React.createElement("span", null, prop.empty);
          }

          return /*#__PURE__*/React.createElement(Select, forwardProps);
        } else if ('input' === prop.type) {
          return /*#__PURE__*/React.createElement("input", {
            type: "text",
            className: "prop-control",
            defaultValue: defaultValue,
            onChange: function onChange(e) {
              return debouncedChange(e.target.value, propKey);
            }
          });
        }
      };

      return !!meta ? /*#__PURE__*/React.createElement("div", {
        className: "item-props expandable"
      }, Object.entries(meta).map(function (_ref5) {
        var _ref6 = _slicedToArray(_ref5, 2),
            propKey = _ref6[0],
            prop = _ref6[1];

        if ('items' in prop && Object.keys(prop.items).length === 0 && 'empty' in prop) {
          return /*#__PURE__*/React.createElement("div", {
            key: propKey,
            className: "empty-message"
          }, prop.empty);
        } else {
          return /*#__PURE__*/React.createElement("div", {
            key: propKey,
            className: "item-prop ".concat(hasQuery && 'input' === prop.type ? 'hidden' : '')
          }, /*#__PURE__*/React.createElement("span", {
            className: "prop-title"
          }, prop.name), renderProp(propKey, prop));
        }
      })) : null;
    };

    var Sorter = function Sorter(_ref7) {
      var rowItems = _ref7.rowItems,
          col = _ref7.col;

      var _React$useState3 = React.useState(clone(rowItems)),
          _React$useState4 = _slicedToArray(_React$useState3, 2),
          list = _React$useState4[0],
          setList = _React$useState4[1];

      var onEnd = function onEnd() {
        var currentItems = list.map(function (itm) {
          return {
            id: itm.id
          };
        });
        updateRows(function (prev) {
          var current = clone(prev);
          current[i].items[col] = currentItems;
          return current;
        });
      };

      return /*#__PURE__*/React.createElement(dist.ReactSortable, {
        list: list,
        setList: setList,
        animation: 150,
        handle: '.drag-handle',
        className: "sortable",
        onEnd: onEnd
      }, rowItems.map(function (item, k) {
        return /*#__PURE__*/React.createElement("div", {
          key: "".concat(col, "-").concat(k),
          className: "gl-col-item".concat(expanded === "".concat(col, "-").concat(k) ? ' open' : '')
        }, /*#__PURE__*/React.createElement("div", {
          className: "item-id",
          onClick: function onClick() {
            return onClickItem(item.id ? item.id : item, col, k);
          }
        }, /*#__PURE__*/React.createElement("span", {
          className: "drag-handle"
        }, "::"), /*#__PURE__*/React.createElement("span", null, item.id ? item.id : item)), /*#__PURE__*/React.createElement("button", {
          className: "item-x",
          onClick: function onClick() {
            return removeItem(col, k);
          }
        }, /*#__PURE__*/React.createElement("span", {
          className: "dashicons dashicons-trash"
        })), /*#__PURE__*/React.createElement(ColItemProps, {
          col: col,
          index: k,
          item: item.id ? item.id : item
        }));
      }));
    };

    return /*#__PURE__*/React.createElement("div", {
      className: "layout-control layout-control-items"
    }, /*#__PURE__*/React.createElement("div", {
      className: "cols-title"
    }, pos, " ", i + 1, " ", __('Items', 'greenlet')), /*#__PURE__*/React.createElement("div", {
      className: "cover-layout-cols-items"
    }, cols.map(function (width, j) {
      var col = j + 1;
      var rowItems = row.items && col in row.items ? row.items[col] : [];
      return /*#__PURE__*/React.createElement("div", {
        key: col,
        className: "cover-layout-col gl-row"
      }, /*#__PURE__*/React.createElement("div", {
        className: "col-name col-2"
      }, "col-", col), /*#__PURE__*/React.createElement("div", {
        className: "col-items col-10"
      }, /*#__PURE__*/React.createElement(Sorter, {
        rowItems: rowItems,
        col: col
      }), /*#__PURE__*/React.createElement(Popup, {
        className: "add-button",
        widthSelector: ".col-items",
        onClose: onClose
      }, /*#__PURE__*/React.createElement("span", {
        className: "dashicons dashicons-plus-alt2"
      }), /*#__PURE__*/React.createElement("div", {
        className: "layout-items"
      }, Object.entries(items).map(function (_ref8) {
        var _ref9 = _slicedToArray(_ref8, 2),
            id = _ref9[0],
            item = _ref9[1];

        return /*#__PURE__*/React.createElement("button", {
          key: id,
          className: "layout-item",
          type: "button",
          onClick: function onClick() {
            return addItem(col, item);
          }
        }, item.name);
      })))));
    })));
  }

  function Layout(_ref) {
    var control = _ref.control,
        updateSettings = _ref.updateSettings;
    var __ = wp.i18n.__;
    var Tooltip = wp.components.Tooltip;
    var _control$params = control.params,
        position = _control$params.position,
        choices = _control$params.choices;

    var _React$useState = React.useState(0),
        _React$useState2 = _slicedToArray(_React$useState, 2),
        expanded = _React$useState2[0],
        setExpanded = _React$useState2[1];

    var _React$useState3 = React.useState(control.setting._value.map(function (row) {
      return _objectSpread2({}, row);
    })),
        _React$useState4 = _slicedToArray(_React$useState3, 2),
        coverRows = _React$useState4[0],
        setRows = _React$useState4[1];

    var _React$useState5 = React.useState(control.setting._value.reduce(function (o, c, i) {
      return _objectSpread2(_objectSpread2({}, o), {}, _defineProperty({}, i, false));
    }, {})),
        _React$useState6 = _slicedToArray(_React$useState5, 2),
        advanced = _React$useState6[0],
        setAdvanced = _React$useState6[1];

    var capitalize = function capitalize(str) {
      return "".concat(str.charAt(0).toUpperCase()).concat(str.slice(1));
    };

    var pos = capitalize(position);
    React.useEffect(function () {
      // Set notification to save and refresh to update sidebars (by coverRows update)
      var sidebars = wp.customize.Widgets.data.registeredSidebars.map(function (sb) {
        return sb.id;
      });
      control.notifications.remove('updateWidgets');
      var extra = false;
      coverRows.forEach(function (row, i) {
        row.columns.split('-').forEach(function (c, j) {
          if (!sidebars.includes("".concat(position, "-sidebar-").concat(i + 1, "-").concat(j + 1))) {
            extra = true;
          }
        });
      });

      if (extra) {
        var message = __('Extra widget areas are added. Please save and refresh this page to reflect new Widget areas', 'greenlet');

        var notification = new wp.customize.Notification('updateWidgets', {
          message: "".concat(message, " (").concat(pos, " Sidebars)"),
          type: 'info'
        });
        control.notifications.add('updateWidgets', notification);
      }
    }, [coverRows]);

    var updateRows = function updateRows(cb) {
      setRows(function (prev) {
        var newRows = cb(JSON.parse(JSON.stringify(prev)));
        updateSettings(newRows);
        return newRows;
      });
    };

    var toggleRow = function toggleRow(e, i) {
      e.stopPropagation();
      setExpanded(function (prev) {
        return prev === i ? -1 : i;
      });
    };

    var toggleAdvanced = function toggleAdvanced(e, i) {
      var val = e.currentTarget.checked;
      setAdvanced(function (prev) {
        return _objectSpread2(_objectSpread2({}, prev), {}, _defineProperty({}, i, val));
      });
    };

    var changePrimary = function changePrimary(e, i) {
      e.stopPropagation();
      setRows(function (prev) {
        var rows = prev.map(function (row) {
          return _objectSpread2({}, row);
        });
        rows.forEach(function (r, m) {
          r['primary'] = m === i;
        });
        updateSettings(rows);
        return rows;
      });
    };

    var changeSticky = function changeSticky(i) {
      setRows(function (prev) {
        var rows = prev.map(function (row) {
          return _objectSpread2({}, row);
        });
        rows[i]['sticky'] = !rows[i]['sticky'];
        updateSettings(rows);
        return rows;
      });
    };

    var changeColumns = function changeColumns(e, i) {
      var columns = e.currentTarget.value;
      setRows(function (prev) {
        var rows = prev.map(function (row) {
          return _objectSpread2({}, row);
        });
        rows[i]['columns'] = columns;
        updateSettings(rows);
        return rows;
      });
    };

    var changeVertical = function changeVertical(e, i) {
      var vertical = e.currentTarget.value;
      setRows(function (prev) {
        var rows = prev.map(function (row) {
          return _objectSpread2({}, row);
        });
        rows[i]['vertical'] = vertical;
        updateSettings(rows);
        return rows;
      });
    };

    var deleteRow = function deleteRow(i) {
      var confirmed = window.confirm("Are you sure you want to remove ".concat(position, " ").concat(i + 1));
      if (!confirmed) return;
      setRows(function (prev) {
        var rows = prev.map(function (row) {
          return _objectSpread2({}, row);
        });
        rows.splice(i, 1);
        updateSettings(rows);
        return rows;
      });
    };

    var addRow = function addRow(placement) {
      setRows(function (prev) {
        var rows = prev.map(function (row) {
          return _objectSpread2({}, row);
        });
        var newRow = {
          columns: '12'
        };

        if ('before' === placement) {
          rows.unshift(newRow);
        } else {
          rows.push(newRow);
        }

        updateSettings(rows);
        return rows;
      });
    };

    return /*#__PURE__*/React.createElement("div", {
      className: "layout-wrap"
    }, /*#__PURE__*/React.createElement("div", {
      className: "add-wrap add-before"
    }, /*#__PURE__*/React.createElement(Tooltip, {
      text: __('Add Header', 'greenlet'),
      position: "top center"
    }, /*#__PURE__*/React.createElement("button", {
      type: "button",
      className: "add-button",
      onClick: function onClick() {
        return addRow('before');
      }
    }, /*#__PURE__*/React.createElement("span", {
      className: "dashicons dashicons-plus-alt2"
    })))), coverRows.map(function (row, i) {
      return /*#__PURE__*/React.createElement("div", {
        key: i,
        className: "row ".concat(expanded === i ? 'expanded' : '')
      }, /*#__PURE__*/React.createElement("div", {
        className: "row-title",
        onClick: function onClick(e) {
          return toggleRow(e, i);
        }
      }, "".concat(pos, " ").concat(i + 1), /*#__PURE__*/React.createElement(Tooltip, {
        text: "".concat(row.primary ? __('Main', 'greenlet') : __('Make this Main', 'greenlet'), " ").concat(pos),
        position: "top left"
      }, /*#__PURE__*/React.createElement("button", {
        type: "button",
        className: "make-primary".concat(row.primary ? ' is-primary' : ''),
        onClick: function onClick(e) {
          return changePrimary(e, i);
        }
      }, /*#__PURE__*/React.createElement("span", {
        className: "dashicons dashicons-star-".concat(row.primary ? 'filled' : 'empty')
      }))), /*#__PURE__*/React.createElement("button", {
        type: "button",
        className: "toggler",
        onClick: function onClick(e) {
          return toggleRow(e, i);
        }
      }, /*#__PURE__*/React.createElement("span", {
        className: "dashicons dashicons-arrow-down"
      }))), /*#__PURE__*/React.createElement("div", {
        className: "row-content"
      }, /*#__PURE__*/React.createElement("div", {
        className: "layout-control customize-control-checkbox"
      }, /*#__PURE__*/React.createElement("span", {
        className: "customize-inside-control-row"
      }, /*#__PURE__*/React.createElement("input", {
        id: "_customize-input-cover_layout_".concat(pos, "-").concat(i, "-sticky"),
        type: "checkbox",
        defaultChecked: row.sticky,
        onChange: function onChange() {
          return changeSticky(i);
        }
      }), /*#__PURE__*/React.createElement("label", {
        htmlFor: "_customize-input-cover_layout_".concat(pos, "-").concat(i, "-sticky")
      }, __('Sticky', 'greenlet')))), /*#__PURE__*/React.createElement("div", {
        className: "layout-control customize-control-template"
      }, /*#__PURE__*/React.createElement("span", {
        className: "title"
      }, __('Select Columns Layout', 'greenlet')), /*#__PURE__*/React.createElement("div", {
        className: "gl-radio-images"
      }, Object.entries(choices).map(function (_ref2) {
        var _ref3 = _slicedToArray(_ref2, 2),
            key = _ref3[0],
            choice = _ref3[1];

        return /*#__PURE__*/React.createElement("div", {
          key: key,
          className: "gl-radio-image"
        }, /*#__PURE__*/React.createElement("label", null, /*#__PURE__*/React.createElement("input", {
          type: "radio",
          name: "".concat(pos, "-").concat(i, "-template"),
          value: key,
          onChange: function onChange(e) {
            return changeColumns(e, i);
          },
          defaultChecked: row.columns === key
        }), /*#__PURE__*/React.createElement("div", {
          className: "icon",
          dangerouslySetInnerHTML: {
            __html: choice
          }
        }), /*#__PURE__*/React.createElement("span", {
          className: "template-name"
        }, key)));
      }))), /*#__PURE__*/React.createElement(RowItems, {
        props: {
          row: row,
          i: i,
          pos: pos,
          updateRows: updateRows,
          control: control
        }
      }), /*#__PURE__*/React.createElement("div", {
        className: "advanced ".concat(advanced[i] ? 'open' : '')
      }, /*#__PURE__*/React.createElement("div", {
        className: "layout-control"
      }, /*#__PURE__*/React.createElement("label", null, /*#__PURE__*/React.createElement("span", {
        className: "title"
      }, __('Enter column numbers separated by hyphen.', 'greenlet'), /*#__PURE__*/React.createElement("br", null), "Eg: ", /*#__PURE__*/React.createElement("code", null, "5-7"), " or ", /*#__PURE__*/React.createElement("code", null, "6-3-3"), ". ", __('Sum should be', 'greenlet'), " ", /*#__PURE__*/React.createElement("code", null, "12")), /*#__PURE__*/React.createElement("input", {
        type: "text",
        onChange: function onChange(e) {
          return changeColumns(e, i);
        }
      }))), /*#__PURE__*/React.createElement("div", {
        className: "layout-control gl-row"
      }, /*#__PURE__*/React.createElement("div", {
        className: "col-4"
      }, /*#__PURE__*/React.createElement("label", {
        htmlFor: "_customize-input-cover_layout_".concat(pos, "-").concat(i, "-vertical")
      }, __('Vertical', 'greenlet'))), /*#__PURE__*/React.createElement("div", {
        className: "col-8"
      }, /*#__PURE__*/React.createElement("select", {
        id: "_customize-input-cover_layout_".concat(pos, "-").concat(i, "-vertical"),
        defaultValue: row.vertical,
        onChange: function onChange(e) {
          return changeVertical(e, i);
        }
      }, /*#__PURE__*/React.createElement("option", {
        value: "no"
      }, __('No', 'greenlet')), /*#__PURE__*/React.createElement("option", {
        value: "left"
      }, __('Left', 'greenlet')), /*#__PURE__*/React.createElement("option", {
        value: "right"
      }, __('Right', 'greenlet')))))), /*#__PURE__*/React.createElement("div", {
        className: "row-footer"
      }, /*#__PURE__*/React.createElement("button", {
        type: "button",
        className: "delete",
        onClick: function onClick() {
          return deleteRow(i);
        }
      }, "".concat(__('Delete', 'greenlet'), " ").concat(pos, " ").concat(i + 1)), /*#__PURE__*/React.createElement("div", {
        className: "advanced-toggle"
      }, /*#__PURE__*/React.createElement("label", null, /*#__PURE__*/React.createElement("span", null, advanced[i] ? __('Hide', 'greenlet') : __('Show', 'greenlet'), " ", __('Advanced', 'greenlet')), /*#__PURE__*/React.createElement("input", {
        type: "checkbox",
        className: "check",
        onChange: function onChange(e) {
          return toggleAdvanced(e, i);
        }
      }))))));
    }), /*#__PURE__*/React.createElement("div", {
      className: "add-wrap add-after"
    }, /*#__PURE__*/React.createElement(Tooltip, {
      text: __('Add Header', 'greenlet'),
      position: "bottom center"
    }, /*#__PURE__*/React.createElement("button", {
      type: "button",
      className: "add-button",
      onClick: function onClick() {
        return addRow();
      }
    }, /*#__PURE__*/React.createElement("span", {
      className: "dashicons dashicons-plus-alt2"
    })))));
  }

  wp.customize.controlConstructor['cover-layout'] = wp.customize.Control.extend({
    ready: function ready() {
      var control = this;

      var updateSettings = function updateSettings(rows) {
        var newRows = rows.map(function (row) {
          return _objectSpread2({}, row);
        });
        control.setting.set(newRows);
      };

      ReactDOM.render( /*#__PURE__*/React.createElement(Layout, {
        control: control,
        updateSettings: updateSettings
      }), document.getElementById("".concat(control.id, "-root")));
      wp.customize.section(control.section(), function (section) {
        section.expanded.bind(function (isExpanded) {
          var sendCoverInit = function sendCoverInit() {
            return wp.customize.previewer.send('start-customize', control.params.position);
          };

          if (isExpanded) {
            sendCoverInit();
            wp.customize.previewer.bind('ready', sendCoverInit);
          } else {
            wp.customize.previewer.send('stop-customize', control.params.position);
            wp.customize.previewer.unbind('ready', sendCoverInit);
          }
        });
      });
    }
  });

  function Sorter(_ref) {
    var items = _ref.items,
        group = _ref.group,
        onChange = _ref.onChange,
        onEnd = _ref.onEnd;

    var changeMeta = function changeMeta(i, ctrl, metaList) {
      var update = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : false;
      var current = clone(items);
      current[i].meta[ctrl].val = metaList;
      onChange(current, update);
    };

    var toggleVisible = function toggleVisible(i) {
      var current = clone(items);
      current[i] = _objectSpread2(_objectSpread2({}, current[i]), {}, {
        visible: !current[i].visible
      });
      onChange(current, true);
    };

    var toggleMeta = function toggleMeta(i) {
      var current = clone(items);
      current[i] = _objectSpread2(_objectSpread2({}, current[i]), {}, {
        open: 'open' in current[i] ? !current[i].open : true
      });
      onChange(current);
    };

    var getEscaped = function getEscaped(_char) {
      var chars = {
        '&nbsp;': "\xA0",
        '&ndash;': "\u2013",
        '&mdash;': "\u2014",
        '&brvbar;': "\xA6",
        '&bull;': "\u2022",
        '&tri;': "\u2023",
        '&hellip;': "\u2026",
        '&lsaquo;': "\u2039",
        '&rsaquo;': "\u203A",
        '&laquo;': "\xAB",
        '&raquo;': "\xBB"
      };
      return _char in chars ? chars[_char] : _char;
    };

    return /*#__PURE__*/React.createElement(dist.ReactSortable, {
      list: items,
      setList: onChange,
      group: group,
      animation: 150,
      handle: '.handle',
      className: "sortable",
      onEnd: onEnd
    }, items.map(function (item, i) {
      return /*#__PURE__*/React.createElement("div", {
        key: item.id,
        className: "item".concat(item.visible ? '' : ' hidden-item')
      }, /*#__PURE__*/React.createElement("span", {
        className: "handle"
      }, "::"), /*#__PURE__*/React.createElement("span", {
        className: "title"
      }, item.name), /*#__PURE__*/React.createElement("button", {
        type: "button",
        onClick: function onClick() {
          return toggleVisible(i);
        }
      }, /*#__PURE__*/React.createElement("span", {
        className: "dashicons dashicons-".concat(item.visible ? 'visibility' : 'hidden')
      })), 'meta' in item && /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement("button", {
        type: "button",
        className: "toggler".concat(item.open ? ' open' : ''),
        onClick: function onClick() {
          return toggleMeta(i);
        }
      }, /*#__PURE__*/React.createElement("span", {
        className: "dashicons dashicons-arrow-down-alt2"
      })), /*#__PURE__*/React.createElement("div", {
        className: "item-meta".concat(item.open ? ' open' : '')
      }, Object.entries(item.meta).map(function (_ref2) {
        var _ref3 = _slicedToArray(_ref2, 2),
            ctrl = _ref3[0],
            meta = _ref3[1];

        return /*#__PURE__*/React.createElement("div", {
          key: ctrl,
          className: "meta-control meta-".concat(ctrl, " control-").concat(meta.type)
        }, meta.label && /*#__PURE__*/React.createElement("div", {
          className: "control-label"
        }, meta.label), meta.desc && /*#__PURE__*/React.createElement("div", {
          className: "control-description"
        }, meta.desc), meta.type === 'sorter' && /*#__PURE__*/React.createElement(Sorter, {
          items: meta.val,
          group: "".concat(group, "-layout"),
          onChange: function onChange(metaList, update) {
            return changeMeta(i, ctrl, metaList, update);
          },
          onEnd: onEnd
        }), meta.type === 'input' && /*#__PURE__*/React.createElement("input", {
          type: "text",
          defaultValue: getEscaped(meta.val),
          onChange: function onChange(e) {
            return changeMeta(i, ctrl, e.target.value, true);
          }
        }), meta.type === 'number' && /*#__PURE__*/React.createElement("input", {
          type: "number",
          defaultValue: getEscaped(meta.val),
          onChange: function onChange(e) {
            return changeMeta(i, ctrl, e.target.value, true);
          }
        }), meta.type === 'radio' && /*#__PURE__*/React.createElement(React.Fragment, null, Object.entries(meta.choices).map(function (_ref4) {
          var _ref5 = _slicedToArray(_ref4, 2),
              choice = _ref5[0],
              label = _ref5[1];

          return /*#__PURE__*/React.createElement("label", {
            key: choice
          }, /*#__PURE__*/React.createElement("input", {
            type: "radio",
            name: ctrl,
            value: choice,
            checked: choice === meta.val,
            onChange: function onChange(e) {
              return changeMeta(i, ctrl, e.target.value, true);
            }
          }), /*#__PURE__*/React.createElement("span", null, label));
        })));
      }))));
    }));
  }

  function ContentLayout(_ref) {
    var control = _ref.control,
        updateSettings = _ref.updateSettings;
    var initItems = clone(control.setting._value);
    var initFlat = [];
    var allFlat = [];
    Object.values(control.params["default"]).forEach(function (v) {
      v.forEach(function (i) {
        return allFlat.push(i.id);
      });
    }); // Format initItems by adding values to default/setting values from Items.

    for (var group in initItems) {
      if (!initItems.hasOwnProperty(group)) continue;
      initItems[group].forEach(function (item) {
        item.name = control.params.items[item.id];
        item.visible = !('visible' in item && !item.visible);

        if ('meta' in item) {
          if ('layout' in item.meta) {
            item.meta.layout.val.forEach(function (metaItem) {
              metaItem.name = control.params.items["meta:".concat(item.id)][metaItem.id];
              metaItem.visible = !('visible' in metaItem && !metaItem.visible);
            });
          }

          for (var ctrl in item.meta) {
            if (!item.meta.hasOwnProperty(ctrl)) continue;

            if (ctrl in control.params.items.controls) {
              item.meta[ctrl] = _objectSpread2(_objectSpread2({}, item.meta[ctrl]), control.params.items.controls[ctrl]);
            }
          }
        }

        initFlat.push(item.id);
      });
    }

    allFlat.forEach(function (itemId) {
      if (!initFlat.includes(itemId)) {
        initItems[Object.keys(initItems).pop()].push({
          id: itemId,
          name: control.params.items[itemId],
          visible: false
        });
      }
    });

    var _React$useState = React.useState(initItems),
        _React$useState2 = _slicedToArray(_React$useState, 2),
        state = _React$useState2[0],
        setState = _React$useState2[1];

    var updateNow = function updateNow() {
      var current = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;
      if (current === false) current = state;
      var formatted = {};

      var _loop = function _loop(_group) {
        if (!current.hasOwnProperty(_group)) return "continue";
        formatted[_group] = [];

        current[_group].forEach(function (item) {
          var fItem = {
            id: item.id,
            visible: item.visible
          };

          if ('meta' in item) {
            fItem.meta = {};

            for (var ctrl in item.meta) {
              if (!item.meta.hasOwnProperty(ctrl)) continue;

              if (item.meta[ctrl].type === 'sorter') {
                fItem.meta[ctrl] = {
                  val: item.meta[ctrl].val.map(function (vi) {
                    return {
                      id: vi.id,
                      visible: vi.visible
                    };
                  })
                };
              } else {
                fItem.meta[ctrl] = {
                  val: item.meta[ctrl].val
                };
              }
            }
          }

          formatted[_group].push(fItem);
        });
      };

      for (var _group in current) {
        var _ret = _loop(_group);

        if (_ret === "continue") continue;
      }

      updateSettings(formatted);
    };

    var _onChange = function onChange(list, group) {
      var update = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;
      setState(function (prev) {
        var current = clone(prev);
        current[group] = list;
        update === true && updateNow(current);
        return current;
      });
    };

    var _React$useState3 = React.useState([]),
        _React$useState4 = _slicedToArray(_React$useState3, 2),
        hiddens = _React$useState4[0],
        setHiddens = _React$useState4[1];

    var onPreviewChange = function onPreviewChange(previewObject) {
      setHiddens(control.params.id === 'content_layout_list' && previewObject.pages.is_home ? ['above'] : []);
    };

    React.useEffect(function () {
      cw.Evt.on('preview-object-ready', onPreviewChange);
    }, []);
    return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement("span", {
      className: "customize-control-title"
    }, control.params.label), /*#__PURE__*/React.createElement("div", {
      className: "gl-sorter ".concat(control.params.cls)
    }, control.params.groups.map(function (group) {
      return /*#__PURE__*/React.createElement("div", {
        className: "group ".concat(group).concat(hiddens.includes(group) ? ' hidden' : ''),
        key: group
      }, /*#__PURE__*/React.createElement("div", {
        className: "group-inner"
      }, control.params.groups.length > 1 && /*#__PURE__*/React.createElement("div", {
        className: "group-title"
      }, group), /*#__PURE__*/React.createElement(Sorter, {
        items: state[group],
        group: control.params.id === 'content_layout_list' && ['above', 'below'].includes(group) ? "".concat(control.params.id, "-").concat(group) : control.params.id,
        onChange: function onChange(list, update) {
          return _onChange(list, group, update);
        },
        onEnd: function onEnd() {
          return updateNow();
        }
      })));
    })));
  }

  /**
   * Content Layout Control.
   *
   * @package greenlet
   */
  wp.customize.controlConstructor['content-layout'] = wp.customize.Control.extend({
    ready: function ready() {
      var control = this;

      var updateSettings = function updateSettings(val) {
        control.setting.set(val);
      };

      ReactDOM.render( /*#__PURE__*/React.createElement(ContentLayout, {
        control: control,
        updateSettings: updateSettings
      }), document.getElementById("".concat(control.id, "-root")));
    }
  });

  /**
   * Length Control.
   *
   * @package greenlet
   */
  wp.customize.controlConstructor['length'] = wp.customize.Control.extend({
    ready: function ready() {
      var Length = cw.components.Length;
      var control = this;

      var onChange = function onChange(data) {
        control.setting.set(data);
      };

      var params = {
        onChange: onChange,
        label: control.params.label,
        subType: control.params.subType,
        val: control.setting._value,
        units: control.params.units
      };
      params.val = undefined === params.val ? '' : params.val;
      ReactDOM.render( /*#__PURE__*/React.createElement("div", {
        className: "cw-control"
      }, /*#__PURE__*/React.createElement(Length, params)), document.getElementById(control.id + '-root'));
    }
  });

  /**
   * Range Control.
   *
   * @package greenlet
   */
  wp.customize.controlConstructor['range'] = wp.customize.Control.extend({
    ready: function ready() {
      var control = this;
      control.container.append('<span class="reset dashicons dashicons-undo"></span>');
      var resetVal = control.setting._value;
      $(control.selector + ' .reset').on('click', function () {
        control.setting.set(resetVal);
      });
    }
  });

  /**
   * Color Control.
   *
   * @package greenlet
   */
  wp.customize.controlConstructor['gl-color'] = wp.customize.Control.extend({
    ready: function ready() {
      var Color = cw.components.Color;
      var control = this;

      var onChange = function onChange(data) {
        control.setting.set(data);
      };

      var params = {
        onChange: onChange,
        label: control.params.label,
        val: control.setting._value
      };
      params.val = undefined === params.val ? '' : params.val;
      ReactDOM.render( /*#__PURE__*/React.createElement("div", {
        className: "cw-control"
      }, /*#__PURE__*/React.createElement(Color, params)), document.getElementById(control.id + '-root'));
    }
  });

  /**
   * Border Control.
   *
   * @package greenlet
   */
  wp.customize.controlConstructor['border'] = wp.customize.Control.extend({
    ready: function ready() {
      // Set initial Values.
      var control = this;
      var widthSelector = $('#border-width-' + control.id);
      var styleSelector = $('#border-style-' + control.id);
      var colorSelector = $('#border-color-' + control.id);
      var border = control.setting._value;
      var borderParts = border.split(' ');
      var width = 0;
      var style = 'none';
      var color = '#000000';

      if (borderParts.length === 3) {
        width = borderParts[0];
        style = borderParts[1];
        color = borderParts[2]; // Set width.

        if (width.indexOf('px') !== -1) {
          width = width.split('px')[0];
        } // Set style options.


        var options = '';
        var styles = ['dotted', 'dashed', 'solid', 'double', 'groove', 'ridge', 'inset', 'outset', 'none', 'hidden'];
        var stylesLength = styles.length;

        for (var i = 0; i < stylesLength; i++) {
          var selected = styles[i] === style ? 'selected' : '';
          options += '<option value="' + styles[i] + '" ' + selected + '>' + styles[i] + '</option>';
        }

        styleSelector.html(options);
      }

      widthSelector.val(width);
      styleSelector.val(style);
      colorSelector.val(color);

      function setBorder() {
        if ($('html').hasClass('window-loaded')) {
          var newValue = widthSelector.val() + 'px ' + styleSelector.val() + ' ' + colorSelector.val();
          control.setting.set(newValue);
        }
      } // Listen to changes.


      widthSelector.on('change', setBorder);
      styleSelector.on('change', setBorder);
      colorSelector.on('change', setBorder);
    }
  });

  wp.customize.controlConstructor['preset'] = wp.customize.Control.extend({
    ready: function ready() {
      var control = this;
      var radios = document.querySelector("".concat(control.selector, " .gl-radio-images"));
      var defaultPreset = control.params.presets['Default'];
      var cw = clone(defaultPreset.color_wings);
      defaultPreset.color_wings = clone(wp.customize.control('color_wings').setting._value);
      defaultPreset.color_wings[cwControlObject.theme] = cw;

      var deepMerge = function deepMerge(targetObject, source) {
        var target = Object.assign({}, targetObject);

        for (var key in source) {
          if (!Object.hasOwnProperty.call(source, key)) {
            continue;
          }

          if (!(key in target)) {
            target[key] = source[key];
          } else if (_typeof(source[key]) === 'object' && !Array.isArray(source[key])) {
            target[key] = deepMerge(target[key], source[key]);
          }
        }

        return target;
      };

      var confirmShown = false;

      var onRadiosChange = function onRadiosChange(e) {
        if ('radio' !== e.target.type) return;
        var confirm = true;

        if (!confirmShown) {
          confirm = window.confirm('This will override all customizer settings and\nApply "' + e.target.value + '" preset.\nProceed?');
          confirmShown = true;
        }

        if (confirm === false) {
          return;
        }

        var preset = clone(control.params.presets[e.target.value]);
        preset.color_wings = _defineProperty({}, cwControlObject.theme, preset.color_wings);
        var currentPreset = e.target.value === 'Default' ? defaultPreset : deepMerge(preset, defaultPreset);

        for (var prop in currentPreset) {
          var singleControl = wp.customize.control(prop);

          if (undefined !== singleControl) {
            singleControl.setting.set(currentPreset[prop]);
          }
        }

        wp.customize.previewer.refresh();
      };

      radios.addEventListener('change', onRadiosChange);
    }
  });

  /**
   * Change Sidebars quantity dependencies.
   */
  function manageSidebarDependencies() {
    var __ = wp.i18n.__;
    var selector = document.getElementById('_customize-input-sidebars_qty');
    selector.addEventListener('change', function (e) {
      var sidebars = e.target.value;
      var templates = document.querySelectorAll('.gl-sequence-content');
      templates.forEach(function (template) {
        var selected = template.value === 'main' ? 'selected' : '';
        var matcherHtml = "<option value=\"main\" ".concat(selected, ">").concat(__('Main Content', 'greenlet'), "</option>");

        for (var j = 1; j <= sidebars; j++) {
          selected = template.value === 'sidebar-' + j ? 'selected' : '';
          matcherHtml += "<option value=\"sidebar-".concat(j, "\" ").concat(selected, ">").concat(__('Sidebar', 'greenlet'), " ").concat(j, "</option>");
        }

        template.innerHTML = matcherHtml;
      });
    });
  }
  /**
   * Manage Post List dependencies.
   */


  function managePostListDependencies() {
    var control = wp.customize.control('post_list_layout');

    if (control.setting._value === 'list') {
      document.getElementById('customize-control-posts_columns').style.display = 'none';
    }

    control.setting.bind(function () {
      if (control.setting._value === 'list') {
        document.getElementById('customize-control-posts_columns').style.display = 'none';
      } else {
        document.getElementById('customize-control-posts_columns').style.display = '';
      }
    });
  }
  /**
   * Manage Performance dependencies.
   */


  function managePerformanceDependencies() {
    var control = wp.customize.control('disable_block_editor');

    if (control.setting._value !== false) {
      document.getElementById('customize-control-defer_block_css').style.display = 'none';
      document.getElementById('customize-control-inline_block_css').style.display = 'none';
    }

    control.setting.bind(function () {
      if (control.setting._value !== false) {
        document.getElementById('customize-control-defer_block_css').style.display = 'none';
        document.getElementById('customize-control-inline_block_css').style.display = 'none';
      } else {
        document.getElementById('customize-control-defer_block_css').style.display = '';
        document.getElementById('customize-control-inline_block_css').style.display = '';
      }
    });
  }
  /**
   * Manage Back to top dependencies.
   */


  function manageToTopDependencies() {
    var control = wp.customize.control('to_top');

    if (control.setting._value === false) {
      document.getElementById('customize-control-to_top_at').style.display = 'none';
    }

    control.setting.bind(function () {
      if (control.setting._value === false) {
        document.getElementById('customize-control-to_top_at').style.display = 'none';
      } else {
        document.getElementById('customize-control-to_top_at').style.display = '';
      }
    });
  }

  wp.customize.bind('ready', function () {
    manageSidebarDependencies();
    managePostListDependencies();
    managePerformanceDependencies();
    manageToTopDependencies();
  });

}(React, Sortable));
//# sourceMappingURL=greenlet-controls.js.map
