(function () {
  'use strict';

  function _slicedToArray(arr, i) {
    return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest();
  }

  function _arrayWithHoles(arr) {
    if (Array.isArray(arr)) return arr;
  }

  function _iterableToArrayLimit(arr, i) {
    if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return;
    var _arr = [];
    var _n = true;
    var _d = false;
    var _e = undefined;

    try {
      for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) {
        _arr.push(_s.value);

        if (i && _arr.length === i) break;
      }
    } catch (err) {
      _d = true;
      _e = err;
    } finally {
      try {
        if (!_n && _i["return"] != null) _i["return"]();
      } finally {
        if (_d) throw _e;
      }
    }

    return _arr;
  }

  function _unsupportedIterableToArray(o, minLen) {
    if (!o) return;
    if (typeof o === "string") return _arrayLikeToArray(o, minLen);
    var n = Object.prototype.toString.call(o).slice(8, -1);
    if (n === "Object" && o.constructor) n = o.constructor.name;
    if (n === "Map" || n === "Set") return Array.from(o);
    if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
  }

  function _arrayLikeToArray(arr, len) {
    if (len == null || len > arr.length) len = arr.length;

    for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i];

    return arr2;
  }

  function _nonIterableRest() {
    throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
  }

  var styles = ":root{--accent: #23b887}svg.svg-def{display:block}.gl-row{display:flex}.gl-row .col-1{width:8.33333%}.gl-row .col-2{width:16.66667%}.gl-row .col-3{width:25%}.gl-row .col-4{width:33.33333%}.gl-row .col-5{width:41.66667%}.gl-row .col-6{width:50%}.gl-row .col-7{width:58.33333%}.gl-row .col-8{width:66.66667%}.gl-row .col-9{width:75%}.gl-row .col-10{width:83.33333%}.gl-row .col-11{width:91.66667%}.gl-row .col-12{width:100%}.gl-layout .gl-layout-control{padding-top:10px}.gl-layout-options{display:flex}.gl-layout-options .components-button{width:50%;justify-content:center}.gl-radio-images{display:flex;flex-wrap:wrap;margin:0 -4px;justify-content:space-between;column-gap:5px}.gl-radio-image{max-width:23%;padding:10px 0}.gl-radio-image label{display:block;position:relative}.gl-radio-image input[type=\"radio\"]{position:absolute;width:0;height:0;opacity:0}.gl-radio-image input[type=\"radio\"]+.gl-icon{color:#fff;background:#c4c8ca;transition:all 0.1s}.gl-radio-image input[type=\"radio\"]+.gl-icon rect{height:36px;y:-10}.gl-radio-image input[type=\"radio\"]:checked+.gl-icon,.gl-radio-image input[type=\"radio\"]:focus+.gl-icon{color:var(--accent);background:#fff}.gl-radio-image input[type=\"radio\"]:not(:checked):hover+.gl-icon{color:#fff;background:var(--accent)}.gl-radio-image svg{width:100%;max-width:58px;height:32px;display:block}.gl-radio-image .template-name{position:absolute;width:100%;height:10px;line-height:1;font-size:11px;text-align:center;bottom:110%;visibility:hidden}.gl-radio-image:hover .template-name{visibility:visible}.gl-sequence{margin-right:-4px;margin-left:-4px;margin-bottom:10px}.gl-sequence-col{padding-top:0;border:1px solid #7e8993;background:#fff;position:relative}.gl-sequence-col:not(:last-child){border-right:none}.gl-sequence-col:first-child{border-radius:3px 0 0 3px}.gl-sequence-col:last-child{border-radius:0 3px 3px 0}.gl-sequence-col:only-child{border-radius:3px}.gl-sequence-col select{width:100%;margin:0;border:none;font-size:12px}.gl-sequence-name{position:absolute;top:110%;left:-1px;font-size:10px;color:#aaa;width:calc( 100% + 2px);text-align:center;overflow:hidden}.gl-sequence-name svg.gl-arrow{position:absolute;left:0;top:4px}.gl-sequence-name svg.gl-arrow.right{transform:rotateZ(180deg);right:0;left:auto}.gl-sequence-name>span{background:#fff;position:relative;padding:0 4px}\n";

  var registerPlugin = wp.plugins.registerPlugin;
  var PluginDocumentSettingPanel = wp.editPost.PluginDocumentSettingPanel;
  var _wp$data = wp.data,
      withSelect = _wp$data.withSelect,
      withDispatch = _wp$data.withDispatch;
  var _wp$components = wp.components,
      Button = _wp$components.Button,
      ButtonGroup = _wp$components.ButtonGroup;
  var useState = wp.element.useState;
  var __ = wp.i18n.__;
  var LayoutMetaField = withDispatch(function (dispatch) {
    return {
      updateMetaValue: function updateMetaValue(v) {
        dispatch('core/editor').editPost({
          meta: {
            greenlet_layout: v
          }
        });
      }
    };
  })(withSelect(function (select) {
    var meta = select('core/editor').getEditedPostAttribute('meta');

    if (undefined === meta || !('greenlet_layout' in meta)) {
      return {};
    }

    return {
      greenlet_layout: meta.greenlet_layout
    };
  })(function (props) {
    if (!('greenlet_layout' in props)) return null;
    var template = 'template' in props.greenlet_layout ? props.greenlet_layout.template : 'default';
    var sequence = 'sequence' in props.greenlet_layout ? props.greenlet_layout.sequence : ['main', 'sidebar-1', 'sidebar-2', 'sidebar-3'];

    var _useState = useState(template),
        _useState2 = _slicedToArray(_useState, 2),
        primary = _useState2[0],
        setPrimary = _useState2[1];

    var updateOption = function updateOption(v) {
      setPrimary(v);
      props.updateMetaValue({
        template: 'default',
        sequence: sequence
      });
    };

    var updateTemplate = function updateTemplate(e) {
      props.updateMetaValue({
        template: e.currentTarget.value,
        sequence: sequence
      });
    };

    var updateSequence = function updateSequence(e) {
      var currentSeq = [];
      e.currentTarget.parentNode.parentNode.querySelectorAll('select.gl-sequence-content').forEach(function (el) {
        return currentSeq.push(el.value);
      });
      props.updateMetaValue({
        template: template,
        sequence: currentSeq
      });
    };

    return /*#__PURE__*/React.createElement("div", {
      className: "gl-layout"
    }, /*#__PURE__*/React.createElement(ButtonGroup, {
      className: "gl-layout-control gl-layout-options",
      "aria-label": "options"
    }, /*#__PURE__*/React.createElement(Button, {
      isSmall: true,
      className: 'default' === primary ? 'is-primary' : 'is-secondary',
      onClick: function onClick() {
        return updateOption('default');
      }
    }, __('Default', 'greenlet')), /*#__PURE__*/React.createElement(Button, {
      isSmall: true,
      className: 'default' === primary ? 'is-secondary' : 'is-primary',
      onClick: function onClick() {
        return updateOption('custom');
      }
    }, __('Custom', 'greenlet'))), 'default' !== primary && /*#__PURE__*/React.createElement("div", {
      className: "gl-layout-control gl-meta-template"
    }, /*#__PURE__*/React.createElement("div", {
      className: "gl-radio-images"
    }, Object.entries(greenletMeta.templates).map(function (_ref) {
      var _ref2 = _slicedToArray(_ref, 2),
          key = _ref2[0],
          choice = _ref2[1];

      return /*#__PURE__*/React.createElement("div", {
        key: key,
        className: "gl-radio-image"
      }, /*#__PURE__*/React.createElement("label", null, /*#__PURE__*/React.createElement("input", {
        type: "radio",
        name: "template",
        value: key,
        onChange: updateTemplate,
        defaultChecked: template === key
      }), /*#__PURE__*/React.createElement("div", {
        className: "gl-icon",
        dangerouslySetInnerHTML: {
          __html: choice
        }
      }), /*#__PURE__*/React.createElement("span", {
        className: "template-name"
      }, key)));
    }))), 'default' !== template && /*#__PURE__*/React.createElement("div", {
      className: "gl-layout-control gl-meta-sequence"
    }, /*#__PURE__*/React.createElement("svg", {
      className: "svg-def",
      width: "0",
      height: "0",
      viewBox: "0 0 201 11"
    }, /*#__PURE__*/React.createElement("defs", null, /*#__PURE__*/React.createElement("g", {
      id: "gl-arrow-shape",
      fill: "#ccc"
    }, /*#__PURE__*/React.createElement("rect", {
      x: "2",
      y: "5",
      width: "199",
      height: "1"
    }), /*#__PURE__*/React.createElement("rect", {
      x: "0",
      y: "0",
      width: "1",
      height: "11",
      fill: "#ddd"
    }), /*#__PURE__*/React.createElement("polygon", {
      points: "1 5.5 4 2 4 9"
    })))), /*#__PURE__*/React.createElement("div", {
      className: "gl-sequence gl-row"
    }, template.split('-').map(function (col, i) {
      return /*#__PURE__*/React.createElement("div", {
        key: i,
        className: "gl-sequence-col col-".concat(col)
      }, /*#__PURE__*/React.createElement("select", {
        className: "gl-sequence-content",
        defaultValue: sequence[i] ? sequence[i] : 'main',
        onChange: updateSequence
      }, Object.entries(greenletMeta.contents).map(function (_ref3) {
        var _ref4 = _slicedToArray(_ref3, 2),
            id = _ref4[0],
            content = _ref4[1];

        return /*#__PURE__*/React.createElement("option", {
          key: id,
          value: id
        }, content);
      })), /*#__PURE__*/React.createElement("div", {
        className: "gl-sequence-name"
      }, /*#__PURE__*/React.createElement("svg", {
        className: "gl-arrow left",
        width: "201px",
        height: "11px",
        viewBox: "0 0 201 11"
      }, /*#__PURE__*/React.createElement("use", {
        href: "#gl-arrow-shape"
      })), /*#__PURE__*/React.createElement("svg", {
        className: "gl-arrow right",
        width: "201px",
        height: "11px",
        viewBox: "0 0 201 11"
      }, /*#__PURE__*/React.createElement("use", {
        href: "#gl-arrow-shape"
      })), /*#__PURE__*/React.createElement("span", null, col)));
    }))));
  }));

  var GreenletLayout = function GreenletLayout() {
    return /*#__PURE__*/React.createElement(PluginDocumentSettingPanel, {
      name: "greenlet-layout",
      title: __('Page Layout', 'greenlet'),
      className: "greenlet-layout",
      icon: "greenlet-layout"
    }, /*#__PURE__*/React.createElement(LayoutMetaField, null), /*#__PURE__*/React.createElement("style", {
      type: "text/css"
    }, styles));
  };

  if (greenletMeta.hasMeta) {
    registerPlugin('greenlet-layout', {
      render: GreenletLayout
    });
  }

}());
//# sourceMappingURL=greenlet-meta.js.map
